unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Mask, Spin, StdCtrls, ComCtrls,math,StrUtils, Menus,ShellAPI;
type
  PUnsigned = array of Cardinal;
  Pint = ^integer;
  individual = record
    chrom: PUnsigned;
    fitness: double;
    varible: double;
    xsite: integer;
    parent: array[0..1] of integer;
    utility: Pint;
  end;
  bestever = record
    chrom: PUnsigned;
    fitness: Double;
    varible: Double;
    generation: Integer;
  end;
 TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    GroupBox1: TGroupBox;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    MaskEdit1: TMaskEdit;
    MaskEdit2: TMaskEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Button1: TButton;
    MaskEdit3: TMaskEdit;
    Button2: TButton;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    Content1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Content1Click(Sender: TObject);
  private
    { Private declarations }
    oldpop, temp, newpop: array of individual;
    bestfit: bestever;
    sumfitness: double;
    max, avg, min: double;
    pcross, pmutation: single;
    popsize, lchrom, chromsize,maxgen: integer;
    printstrings: boolean; //* Ⱦɫжϣ */
    gen,  run, maxruns: integer;
    nmutation: integer; //* ǰ췢 */
    ncross: integer;
    procedure initpop;
    procedure objfunc(var critter: individual);
    function flip(prob: single): boolean;
    function select: integer;
    function crossover(var parent1, parent2, child1, child2: PUnsigned): integer;
    function rnd(low, high: integer): integer;
    procedure mutation(child: PUnsigned);
    procedure generation;
    procedure preselect;
    constructor Create;
    procedure initdata;
    procedure initmalloc;
    procedure statistics(pop: array of individual);
    procedure Go;
    procedure report;
    procedure writepop;
    procedure GARandomize;
    procedure advance_random;
    function randomperc: single;
    function randomnormaldeviate: double;
    function ChromToString(chrom: PUnsigned):string;
    procedure warmup_random(random_seed: single);
  public
    { Public declarations }
  end;
var
  Form1: TForm1;
implementation

uses about;
{$R *.dfm}
var
  oldrand: array[0..54] of double;
  jrand: integer;
  rndx2: double;
  rndcalcflag: integer;

procedure Tform1.GARandomize; // * 趨Ӳʼ * /
var
  randomseed: single;
  j1: integer;
begin
  for j1 := 0 to 54 do
    oldrand[j1] := 0.0;
  jrand := 0;
  randomseed:=strtoFloat(maskedit3.Text);
  warmup_random(randomseed);
end;

procedure Tform1.warmup_random(random_seed: single); // * ʼ * /
var
  j1, ii: integer;
  new_random, prev_random: double;
begin
  oldrand[54] := random_seed;
  new_random := 0.000000001;
  prev_random := random_seed;
  for j1 := 1 to 54 do
  begin
    ii := (21 * j1) mod 54;
    oldrand[ii] := new_random;
    new_random := prev_random - new_random;
    if (new_random < 0.0) then
      new_random := new_random + 1.0;
    prev_random := oldrand[ii];
  end;
  advance_random;
  advance_random();
  advance_random();
  jrand := 0;
end;

procedure Tform1.advance_random; //* 55 */
var
  j1: integer;
  new_random: double;
begin
  for j1 := 0 to 23 do
  begin
    new_random := oldrand[j1] - oldrand[j1 + 31];
    if (new_random < 0.0) then
      new_random := new_random + 1.0;
    oldrand[j1] := new_random;
  end;
  for j1 := 24 to 54 do
  begin
    new_random := oldrand[j1] - oldrand[j1 - 24];
    if (new_random < 0.0) then new_random := new_random + 1.0;
    oldrand[j1] := new_random;
  end;
end;

function Tform1.randomnormaldeviate: double; //* ׼ */
var
  t, rndx1: double;
begin

  if rndcalcflag = 1 then
  begin
    rndx1 := sqrt(-2.0 * log2(randomperc));
    t := 6.2831853072 * randomperc;
    rndx2 := rndx1 * sin(t);
    rndcalcflag := 0;
    result := (rndx1 * cos(t));
  end
  else
  begin
    rndcalcflag := 1;
    result := (rndx2);
  end;
end;

function Tform1.randomperc: single;
  //*⺯random()ͬ, [0,1]֮һ */
begin
  inc(jrand, 1);
  if (jrand >= 55) then
  begin
    jrand := 1;
    advance_random();
  end;
  result := oldrand[jrand];
end;

constructor Tform1.Create; //* Ŵ㷨ʼ */
begin
     //* Ŵ㷨 */
  initdata;
    //* ȷȾɫֽڳ */
  chromsize := (lchrom div (8 * sizeof(cardinal)));
  if ((lchrom mod (8 * sizeof(cardinal))) = 0) or (lchrom < (8 *
    sizeof(cardinal)))  then
    inc(chromsize, 1);
    //*ȫݽṹռ */
  initmalloc;
    //* ʼ */
  GArandomize;
    //* ʼȫּһЩֵ*/
  nmutation := 0;
  ncross := 0;
  bestfit.fitness := 0.0;
  bestfit.generation := 0;
    //* ʼȺͳƼ */
  initpop;
  statistics(oldpop);
end;

procedure Tform1.statistics(pop: array of individual); //* Ⱥͳ */
var
  i, j: integer;
begin
  sumfitness := 0.0;
  min := pop[0].fitness;
  max := pop[0].fitness;
    //* СۼӦ */
  for j := 0 to popsize - 1 do
  begin
    sumfitness := sumfitness + pop[j].fitness;
    if (pop[j].fitness > max) then
      max := pop[j].fitness;
    if (pop[j].fitness < min) then
      min := pop[j].fitness;
    // * new global best - fit individual * /
    if (pop[j].fitness > bestfit.fitness) then
    begin
      for i := 0 to chromsize - 1 do
        bestfit.chrom[i] := pop[j].chrom[i];
      bestfit.fitness := pop[j].fitness;
      bestfit.varible := pop[j].varible;
      bestfit.generation := gen;
    end;
  end;
  // * ƽӦ * /
  avg := sumfitness / popsize;
end;

procedure Tform1.initmalloc;
var
  nbytes: cardinal;
  j: integer;
begin
//  char  *malloc();
  //* ǰһȺڴռ */
 // nbytes = popsize * sizeof(individual);
{  if((oldpop = (struct individual *) malloc(nbytes)) == NULL)
    nomemory("oldpop")}
  setlength(oldpop, popsize);
  setlength(newpop, popsize);
{  if((newpop = (struct individual *) malloc(nbytes)) == NULL)
    nomemory("newpop");}
  //* Ⱦɫڴռ */
//  nbytes = chromsize * sizeof(unsigned);
  for j := 0 to popsize - 1 do
  begin
    {  if((oldpop[j].chrom = (unsigned *) malloc(nbytes)) == NULL)
 nomemory("oldpop chromosomes");}
    SetLength(oldpop[j].chrom, chromsize);
    SetLength(newpop[j].chrom, chromsize);
    {  if((newpop[j].chrom = (unsigned *) malloc(nbytes)) == NULL)
 nomemory("newpop chromosomes");}
  end;
  SetLength(bestfit.chrom, chromsize);
end;

procedure Tform1.initdata; //* Ŵ㷨 */
begin
  PopSize:=SpinEdit1.Value;
  if (PopSize mod 2)<>0 then inc(PopSize);
  lChrom:=SpinEdit2.Value;
  maxGen:=SpinEdit3.Value;
  PCross:=strtofloat(MaskEdit1.text);
  PMutation:=strToFloat(MaskEdit2.Text);
  printstrings:=checkBox1.Checked;
end;

procedure Tform1.initpop;
var
  j, j1, k, stop: integer;
  mask: Cardinal;
begin
  mask := 1;
  for j := 0 to popsize - 1 do
  begin
    for k := 0 to chromsize - 1 do
    begin
      oldpop[j].chrom[k] := 0;
      if k = chromsize - 1 then
        stop := lchrom - (k * (8 * sizeof(cardinal)))
      else
        stop := 8 * sizeof(cardinal);
      for j1 := 1 to stop do
      begin
        oldpop[j].chrom[k] := oldpop[j].chrom[k] shl 1;
        if flip(0.5) then
          oldpop[j].chrom[k] := oldpop[j].chrom[k] or mask;
      end;
      oldpop[j].parent[0] := 0;
      oldpop[j].parent[1] := 0;
      oldpop[j].xsite := 0;
      objfunc(oldpop[j]);
    end;
  end;
end;

procedure Tform1.objfunc(var critter: individual); //* ӦȺֵ */
var
  mask, bitpos, tp: cardinal;
  bitpow: double;
  j, k, stop: integer;
begin
  mask := 1;
  critter.varible := 0.0;
  for k := 0 to chromsize - 1 do
  begin
    if (k = (chromsize - 1)) then
      stop := lchrom - (k * (8 * sizeof(cardinal)))
    else
      stop := 8 * sizeof(cardinal);
    tp := critter.chrom[k];
    for j := 0 to stop - 1 do
    begin
      bitpos := j + (8 * sizeof(cardinal)) * k;
      if ((tp and mask) = 1) then
      begin
        bitpow := power(2.0, bitpos);
        critter.varible := critter.varible + bitpow;
      end;
      tp := tp shr 1;
    end;
  end;
  //ɶƴӦx'x=-1.0+x'*3/(power(2,lenght)-1)
  critter.varible := -1 + critter.varible * 3 / (power(2.0, lchrom) - 1);
  //f(x)=x*sin(10pi*x)+2.0
  critter.fitness := critter.varible * sin(critter.varible * 10 * arctan(1)   
    * 4) + 2.0;
end;


function Tform1.flip(prob: single): boolean; // һʲ01
begin
  if (randomperc <= prob) then
    result := true
  else
    result := false;
end;

function Tform1.select: integer; //* ̶ѡ*/
var
  sum, pick: single;
  i: integer;
begin
  pick := randomperc;
  sum := 0;
  i := 0;
  if (sumfitness <> 0) then
    while ((sum < pick) and (i < popsize)) do
    begin
      sum := sum + oldpop[i].fitness / sumfitness;
      inc(i);
    end
  else
    i := rnd(1, popsize);
  result := i - 1;
end;

function Tform1.rnd(low, high: integer): integer;
  //*lowhigh֮һ*/
var
  i: integer;
begin
  if (low >= high) then
    i := low
  else
  begin
    i := trunc((randomperc * (high - low + 1)) + low);
    if (i > high) then
      i := high;
  end;
  result := i;
end;

function Tform1.crossover(var parent1, parent2, child1, child2: PUnsigned): integer;
  // * 彻Ӹ * /
var
  j, jcross, k: integer;
  mask, temp: cardinal;
begin
  if (flip(pcross)) then
  begin
    jcross := rnd(1, (lchrom - 1)); // * Cross between 1 and l - 1 * /
    inc(ncross, 1);
    for k := 1 to chromsize do
    begin
      if (jcross >= (k * (8 * sizeof(cardinal)))) then
      begin
        child1[k - 1] := parent1[k - 1];
        child2[k - 1] := parent2[k - 1];
      end
      else
        if ((jcross < (k * (8 * sizeof(cardinal)))) and (jcross > ((k - 1) * (8 *
          sizeof(cardinal))))) then
        begin
          mask := 1;
          for j := 1 to jcross - 1 - ((k - 1) * (8 * sizeof(cardinal))) do
          begin
            temp := 1;
            mask := mask shr 1;
            mask := mask and temp;
          end;
          child1[k - 1] := (parent1[k - 1] and mask) or (parent2[k - 1] and (not
            mask));
          child2[k - 1] := (parent1[k - 1] and (not mask)) or (parent2[k - 1] and
            mask);
        end
        else
        begin
          child1[k - 1] := parent2[k - 1];
          child2[k - 1] := parent1[k - 1];
        end;
    end;
  end
  else
  begin
    for k := 0 to chromsize - 1 do
    begin
      child1[k] := parent1[k];
      child2[k] := parent2[k];
    end;
    jcross := 0;
  end;
  result := jcross;
end;

procedure Tform1.mutation(child: PUnsigned); //**/
var
  j, k, stop: integer;
  mask, temp: cardinal;
begin
  temp := 1;
  for k := 0 to chromsize - 1 do
  begin
    mask := 0;
    if (k = (chromsize - 1)) then
      stop := lchrom - (k * (8 * sizeof(cardinal)))
    else
      stop := 8 * sizeof(cardinal);
    for j := 0 to stop - 1 do
    begin
      if (flip(pmutation)) then
      begin
        mask := mask or (temp shl j);
        inc(nmutation, 1);
      end;
    end;
    child[k] := child[k] xor mask;
  end;
end;

procedure Tform1.generation;
var
  mate1, mate2, jcross, j: integer;
begin
  j := 0;
  //*  ÿǰԤѡ */
  preselect;
  //* ѡ, ,  */
  repeat
      //* ѡ */
    mate1 := select();
    mate2 := select();
      //* ͱ */
    jcross := crossover(oldpop[mate1].chrom, oldpop[mate2].chrom, newpop[j].chrom,
      newpop[j + 1].chrom);
    mutation(newpop[j].chrom);
    mutation(newpop[j + 1].chrom);
      //* , Ӧ */
    objfunc(newpop[j]);
      //*¼ӹϵͽλ */
    newpop[j].parent[0] := mate1 + 1;
    newpop[j].xsite := jcross;
    newpop[j].parent[1] := mate2 + 1;
    objfunc(newpop[j + 1]);
    newpop[j + 1].parent[0] := mate1 + 1;
    newpop[j + 1].xsite := jcross;
    newpop[j + 1].parent[1] := mate2 + 1;
    j := j + 2;
  until (j >= (popsize - 1));
end;

procedure Tform1.preselect;
var
  j: integer;
begin
  sumfitness := 0;
  for j := 0 to popsize - 1 do
    sumfitness := sumfitness + oldpop[j].fitness;
end;

procedure Tform1.Go;
begin
  gen := 0;
  while (gen < maxgen) do
  begin
      //fprintf(outfp, "\n %d / %d : ǰΪ %d,  %d \n", run, maxruns,
        //gen, maxgen);
      // * һ * /
    generation;
      // * һȺӦͳ * /
    statistics(newpop);
      // * һͳ * /
    report;

    temp := copy(oldpop);
    oldpop := copy(newpop);
    newpop := copy(temp);
    inc(gen, 1);
  end;
//  freeall();
end;

procedure Tform1.report; //* Ⱥͳƽ */
var dashCount:integer;
begin
 dashCount:=80+(lChrom-22)*2;
 richedit1.Lines.Add(StringOfChar('-',dashCount));
 if printstrings  then begin
    richedit1.Lines.Add(StringOfChar(' ',(16+lChrom*2)div 2)+ 'ģͳƱ');
    richedit1.Lines.Add(StringOfchar(' ',(8+lChrom)div 2)+ ':'+inttostr(gen)+StringOfChar(' ',lChrom+(lChrom div 2))+':'+inttostr(gen+1));
    richedit1.Lines.Add(''+stringOfChar(' ',(lChrom -10)div 2)+'Ⱦɫ' +stringOfChar(' ',(lChrom -10)div 2)+ ' Ӧ      λ  '+stringOfChar(' ',lChrom div 2-8)+'Ⱦɫ'+stringOfChar(' ',lChrom div 2-5) +'Ӧ');
    richedit1.Lines.Add(StringOfChar('-',dashCount));
    writepop();
    richedit1.Lines.Add(StringOfChar('-',dashCount));
 end;
 richedit1.Lines.Add( format(' %d ͳ: ', [gen]));
 richedit1.Lines.Add(' ܽ = '+IntTostr(ncross)+ ' ܱ = '+inttostr(nmutation));
 richedit1.Lines.Add( ' СӦȣ'+leftstr(floattostr(min),4)+ ' Ӧȣ'+leftstr(floattostr(max),4)+ ' ƽӦ:'+leftstr(floattostr(avg),4));
 richedit1.Lines.Add( format(' Ѹ =>  ڴ %d  ', [bestfit.generation]));
 richedit1.Lines.Add( ' Ӧȣ '+floattostr(bestfit.fitness));
 richedit1.Lines.Add( ' Ⱦɫ壺'+ChromToString(bestfit.chrom));
 richedit1.Lines.Add( ' Ӧıֵ: '+floattostr(bestfit.varible));
 richedit1.Lines.Add( '');
end;

procedure Tform1.writepop;
var
  pind: individual;
  j: integer;
begin
  for j := 0 to popsize - 1 do
  begin
    pind := newpop[j];
    richedit1.Lines.Add(format('%3d) ',[j+1])+ ChromToString(oldpop[j].chrom)+ format(' %5f | ', [pind.fitness]) +format('(%3d,%3d)   %2d  ', [pind.parent[0], pind.parent[1],pind.xsite]) +ChromToString(pind.chrom )+format(' %5f', [pind.fitness]));
   end;
end;

function Tform1.ChromToString(chrom: PUnsigned):string;
  var
    j, k, stop: integer;
    mask, tmp: Cardinal;
  begin
    mask := 1;
    result:='';
    for k := 0 to chromsize - 1  do
    begin
      tmp := chrom[k];
      if (k = (chromsize - 1)) then
        stop := lchrom - (k * (8 * sizeof(cardinal)))
      else
        stop := 8 * sizeof(cardinal);
      for j := 0 to stop - 1 do
      begin
        if (tmp and mask) = 1 then
           result:='1'+result//write('1')
        else
           result:='0'+result;//write('0');
        tmp := tmp shr 1;
      end;
    end;
end;


procedure TForm1.Button1Click(Sender: TObject);
var Save_Cursor:TCursor;
begin
 richedit1.Clear;
 Save_Cursor := Screen.Cursor;
 Screen.Cursor := crHourGlass;
 Create;
 Go;
 Screen.Cursor := Save_Cursor;
 showmessage('.');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Randomize;
maskedit3.text:=floattostrF(random,ffGeneral,10,7);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
Button2Click(sender);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.showmodal;
end;

procedure TForm1.Content1Click(Sender: TObject);
begin
shellexecute(handle,'open','GA.hlp',nil,nil,sw_shownormal);
end;

end.
